## ros-noetic-variant-topic-tools 0.1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(variant_topic_tools)

# Set the build type.  Options are:
#  Coverage       : w/ debug symbols, w/o optimization, w/ code-coverage
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries
# set(CMAKE_BUILD_TYPE RelWithDebInfo)

add_definitions(-std=c++11)

## Find catkin macros and libraries
find_package(catkin REQUIRED
  COMPONENTS
    roscpp
    roslib
    variant_msgs
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES variant_topic_tools
  CATKIN_DEPENDS
    roscpp
    roslib
    variant_msgs
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(variant_topic_tools
  src/ArrayDataType.cpp
  src/ArraySerializer.cpp
  src/ArrayVariant.cpp
  src/BuiltinDataType.cpp
  src/BuiltinSerializer.cpp
  src/BuiltinVariant.cpp
  src/CollectionVariant.cpp
  src/DataType.cpp
  src/DataTypeRegistry.cpp
  src/Exceptions.cpp
  src/MD5Sum.cpp
  src/Message.cpp
  src/MessageConstant.cpp
  src/MessageDataType.cpp
  src/MessageDefinition.cpp
  src/MessageDefinitionParser.cpp
  src/MessageHeader.cpp
  src/MessageMember.cpp
  src/MessageSerializer.cpp
  src/MessageTraits.cpp
  src/MessageType.cpp
  src/MessageTypeParser.cpp
  src/MessageVariable.cpp
  src/MessageVariant.cpp
  src/Publisher.cpp
  src/Serialization.cpp
  src/Serializer.cpp
  src/Subscriber.cpp
  src/Variant.cpp
)

add_executable(
  echo
  src/echo.cpp
)
add_executable(
  info
  src/info.cpp
)
add_executable(
  publish
  src/publish.cpp
)
add_executable(
  relay
  src/relay.cpp
)

## Specify libraries to link a library or executable target against
target_link_libraries(
  variant_topic_tools
  ${catkin_LIBRARIES}
)

target_link_libraries(
  echo
  variant_topic_tools
  ${catkin_LIBRARIES}
)
target_link_libraries(
  info
  variant_topic_tools
  ${catkin_LIBRARIES}
)
target_link_libraries(
  publish
  variant_topic_tools
  ${catkin_LIBRARIES}
)
target_link_libraries(
  relay
  variant_topic_tools
  ${catkin_LIBRARIES}
)

#############
## Install ##
#############

# Mark executables and/or libraries for installation
install(
  TARGETS ${PROJECT_NAME} echo info publish relay
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Mark cpp header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING
  PATTERN "*.hpp"
  PATTERN "*.h"
  PATTERN "*.tpp"
)

##########
## Test ##
##########
if(CATKIN_ENABLE_TESTING)
  find_package(catkin REQUIRED COMPONENTS
    geometry_msgs
    std_msgs
  )

  catkin_add_gtest(test_${PROJECT_NAME}
    test/variant_topic_test.cpp
    test/DataTypeTest.cpp
    test/DataTypeRegistryTest.cpp
    test/MD5SumTest.cpp
    test/MessageDefinitionTest.cpp
    test/MessageDefinitionParserTest.cpp
    test/MessageFieldCollectionTest.cpp
    test/MessageTest.cpp
    test/MessageTypeParserTest.cpp
    test/MessageTypeTest.cpp
    test/PointerTest.cpp
    test/SerializerTest.cpp
    test/VariantTest.cpp
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/test
  )

  if(TARGET test_${PROJECT_NAME})
    target_link_libraries( test_${PROJECT_NAME}
      ${PROJECT_NAME}
      ${catkin_LIBRARIES}
    )
    find_package(cmake_code_coverage QUIET)
    if(cmake_code_coverage_FOUND)
      add_gtest_coverage()
    endif(cmake_code_coverage_FOUND)
  endif()
endif()

=== debian/changelog ===
ros-noetic-variant-topic-tools (0.1.6-1buster) buster; urgency=high

  * Allow 0 in message definition
  * Contributors: Kenji Miyake

 -- Samuel Bachmann <sbachmann@anybotics.com>  Tue, 05 Jan 2021 23:00:00 -0000

ros-noetic-variant-topic-tools (0.1.5-1buster) buster; urgency=high

  * fix cmake
  * Contributors: Samuel Bachmann

 -- Samuel Bachmann <sbachmann@anybotics.com>  Thu, 22 Nov 2018 23:00:00 -0000

ros-noetic-variant-topic-tools (0.1.4-1buster) buster; urgency=high

  * fix build issue in ROS Melodic (cannot convert boost::shared_ptr to bool)
  * Fix for package and topic names containing zeros
  * Contributors: Fabian H, Samuel Bachmann, Zezao Lu

 -- Samuel Bachmann <sbachmann@anybotics.com>  Tue, 20 Nov 2018 23:00:00 -0000

ros-noetic-variant-topic-tools (0.1.3-1buster) buster; urgency=high

  * add executables to install
  * add install commands
  * Contributors: Samuel Bachmann

 -- Samuel Bachmann <sbachmann@anybotics.com>  Thu, 19 May 2016 22:00:00 -0000

ros-noetic-variant-topic-tools (0.1.2-1buster) buster; urgency=high

  * update readme with build status
  * remove cmake_modules dependency
  * Contributors: Samuel Bachmann

 -- Samuel Bachmann <sbachmann@anybotics.com>  Wed, 18 May 2016 22:00:00 -0000

ros-noetic-variant-topic-tools (0.1.1-1buster) buster; urgency=high

  * Fixes related to OS X clang compatibility
  * Fixed some issues of subscriber
  * Fixed bug in MessageDefinition::setMessageType() which was caused by a wrong order of defining the required message types of a message type
  * Added message data type member access by name
  * 
    
      * Added type name resolution for member definitions neglecting package names
      * Added receipt time to variant subscriber callback
    
  * 
    
      * Code cleanups
      * Added variant publisher and subscriber
      * Added MD5 sum calculation for variant message types
      * Updated README
    
  * Added convenience serialization methods to message class
  * Added method for serializer creation to variants
  * Basic serializer testing
  * Added numeric value access for built-in types
  * Message variant tests successful
  * Message data type now separates constant and variable members
  * Reverted templated variant value to represent actual value type
  * Refined traits, code cleanups
  * Removed SharedVariant and friend-relationship between Variant and CollectionVariant
  * Renamed some classes, code cleanups
  * 
    
      * Created test package
      * Moved test binaries to test package
    
  * Contributors: Ralf Kaestner

 -- Samuel Bachmann <sbachmann@anybotics.com>  Wed, 11 May 2016 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-variant-topic-tools
Section: misc
Priority: optional
Maintainer: Samuel Bachmann <sbachmann@anybotics.com>
Build-Depends: debhelper (>= 9.0.0), libgtest-dev, ros-noetic-catkin, ros-noetic-geometry-msgs, ros-noetic-roscpp, ros-noetic-roslib, ros-noetic-std-msgs, ros-noetic-variant-msgs
Homepage: http://github.com/anybotics/variant
Standards-Version: 3.9.2

Package: ros-noetic-variant-topic-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-roscpp, ros-noetic-roslib, ros-noetic-variant-msgs
Description: Topic tools for treating messages as variant types.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-variant-topic-tools//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
